#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_action_Quit_triggered()
{
    close();
}

#include <QDir>

void MainWindow::on_action_Run_triggered()
{
    QDir dir ("/usr/share/icons/oxygen/base");
    QTreeWidgetItem * item = new QTreeWidgetItem;
    QString path = dir.absolutePath();
    item->setText (0, path);
    item->setToolTip (0, path);
    item->setData (0, Qt::UserRole, path);
    item->setForeground (0, QColor ("red"));
    item->setIcon (0, QIcon::fromTheme ("folder"));
    ui->treeWidget->invisibleRootItem()->addChild (item);
    showDir(item, dir);
}

void MainWindow::showDir (QTreeWidgetItem *target, QDir dir)
{
    QFileInfoList list = dir.entryInfoList
             (QDir::NoDotAndDotDot | QDir::AllEntries , QDir::Name);
    for (QFileInfo info : list)
    {
        QTreeWidgetItem * item = new QTreeWidgetItem;
        item->setText (0, info.fileName());
        QString path = info.absoluteFilePath();
        item->setToolTip (0, path);
        item->setData (0, Qt::UserRole, path);
        target->addChild(item);
        if (info.isDir())
        {
            item->setForeground (0, QColor ("red"));
            item->setIcon (0, QIcon::fromTheme ("folder"));
            showDir (item, QDir (path));
        }
        else
        {
            item->setForeground (0, QColor ("blue"));
            QString ext = info.suffix();
            QString fname = path;
            if (ext == "cpp")
                item->setForeground (0, QColor ("lime"));
            else if (ext == "png")
            {
                item->setForeground (0, QColor ("orange"));
                QIcon icon = QIcon (fname);
                item->setIcon (0, icon);
            }
        }
    }
}

void MainWindow::on_treeWidget_itemClicked(QTreeWidgetItem *item, int column)
{
    QString path = item->data (0, Qt::UserRole).toString();
    ui->textEdit->append ("Click " + path);
}
